diff -uNr syslog-ng-1.5.13.orig/src/affile.h syslog-ng-1.5.13/src/affile.h
--- syslog-ng-1.5.13.orig/src/affile.h	Sun Aug 26 17:06:25 2001
+++ syslog-ng-1.5.13/src/affile.h	Thu Apr 18 22:34:35 2002
@@ -48,6 +48,8 @@
 #define AFFILE_FSYNC          0x0020
 #define AFFILE_FSYNC_SHIFT    5
 
+struct ol_string *expand_macros(struct syslog_config *cfg, struct ol_string *template, int template_escape, struct log_info *msg);
+
 void affile_set_syncfreq(struct log_dest_driver *affile, int syncfreq);
 void affile_set_fsync(struct log_dest_driver *c, int enable);
 void affile_set_compress(struct log_dest_driver *affile, int enable);
diff -uNr syslog-ng-1.5.13.orig/src/afprogram.c syslog-ng-1.5.13/src/afprogram.c
--- syslog-ng-1.5.13.orig/src/afprogram.c	Sun Jul  8 19:04:21 2001
+++ syslog-ng-1.5.13/src/afprogram.c	Thu Apr 18 22:34:28 2002
@@ -23,6 +23,9 @@
  *
  ***************************************************************************/
 
+/* Needed for expand_macros() */
+#include "affile.h"
+
 #include "afprogram.h"
 #include "destinations.h"
 #include "cfgfile.h"
@@ -44,6 +47,9 @@
      (super log_dest_driver)
      (vars
        (progname string)
+       (cfg object syslog_config)
+       (template_output string)
+       (template_escape . int)
        (dest object io_fd)))
 */
 
@@ -106,6 +112,7 @@
 		REMEMBER_RESOURCE(cfg->resources, &self->dest->super.super);
 	}
 
+	self->cfg = cfg;
 	return ST_OK | ST_GOON;
 }
 
@@ -114,13 +121,14 @@
 {
         CAST(afprogram_dest, self, c);
 
-        if (self->dest)
-                A_WRITE_STRING(&self->dest->buffer->super, 
-			       c_format("<%i>%S %S %S\n", 
-					msg->pri, 
-					msg->date, 
-					msg->host, 
-					msg->msg));
+        if (self->dest) {
+	  struct ol_string *l;
+	  if (self->template_output)
+	    l = expand_macros(self->cfg, self->template_output, self->template_escape, msg);
+	  else
+	    l = c_format("<%i>%S %S %S\n", msg->pri, msg->date, msg->host, msg->msg);
+	  A_WRITE_STRING(&self->dest->buffer->super, l);
+	}
         log_info_free(msg);
 }
 
@@ -133,3 +141,18 @@
 	self->progname = c_format_cstring("%z", cmd);
 	return &self->super;
 }
+
+void afprogram_set_template(struct log_dest_driver *c, char *t)
+{
+	CAST(afprogram_dest, self, c);
+
+	self->template_output = c_format("%z", t);
+}
+
+void afprogram_set_template_escape(struct log_dest_driver *c, int enable)
+{
+	CAST(afprogram_dest, self, c);
+
+	self->template_escape = enable;
+}
+
diff -uNr syslog-ng-1.5.13.orig/src/afprogram.c.x syslog-ng-1.5.13/src/afprogram.c.x
--- syslog-ng-1.5.13.orig/src/afprogram.c.x	Sun Jul  8 19:09:41 2001
+++ syslog-ng-1.5.13/src/afprogram.c.x	Thu Apr 18 22:34:58 2002
@@ -3,6 +3,9 @@
 {
   struct log_dest_driver super;
   struct ol_string *progname;
+  struct syslog_config *cfg;
+  struct ol_string *template_output;
+  int template_escape;
   struct io_fd *dest;
 };
 extern struct ol_class afprogram_dest_class;
@@ -13,6 +16,7 @@
 void (*mark)(struct ol_object *o))
 {
   struct afprogram_dest *i = (struct afprogram_dest *) o;
+  mark((struct ol_object *) i->cfg);
   mark((struct ol_object *) i->dest);
 }
 
@@ -20,6 +24,7 @@
 {
   struct afprogram_dest *i = (struct afprogram_dest *) o;
   ol_string_free(i->progname);
+  ol_string_free(i->template_output);
 }
 
 struct ol_class afprogram_dest_class =
diff -uNr syslog-ng-1.5.13.orig/src/afprogram.h syslog-ng-1.5.13/src/afprogram.h
--- syslog-ng-1.5.13.orig/src/afprogram.h	Sun Feb 25 13:00:22 2001
+++ syslog-ng-1.5.13/src/afprogram.h	Thu Apr 18 22:35:55 2002
@@ -29,5 +29,7 @@
 #include "syslog-ng.h"
 
 struct log_dest_driver *make_afprogram_dest(const char *cmd);
+void afprogram_set_template(struct log_dest_driver *c, char *t);
+void afprogram_set_template_escape(struct log_dest_driver *c, int enable);
 
 #endif
diff -uNr syslog-ng-1.5.13.orig/src/cfg-grammar.c syslog-ng-1.5.13/src/cfg-grammar.c
--- syslog-ng-1.5.13.orig/src/cfg-grammar.c	Mon Sep  3 18:46:16 2001
+++ syslog-ng-1.5.13/src/cfg-grammar.c	Thu Apr 18 22:55:09 2002
@@ -1,87 +1,15 @@
-
-/*  A Bison parser, made from cfg-grammar.y
-    by GNU Bison version 1.28  */
-
-#define YYBISON 1  /* Identify Bison output.  */
-
-#define	KW_SOURCE	257
-#define	KW_DESTINATION	258
-#define	KW_LOG	259
-#define	KW_OPTIONS	260
-#define	KW_FILTER	261
-#define	KW_INTERNAL	262
-#define	KW_FILE	263
-#define	KW_PIPE	264
-#define	KW_UNIX_STREAM	265
-#define	KW_UNIX_DGRAM	266
-#define	KW_UDP	267
-#define	KW_TCP	268
-#define	KW_USER	269
-#define	KW_DOOR	270
-#define	KW_SUN_STREAMS	271
-#define	KW_PROGRAM	272
-#define	KW_REMCTRL	273
-#define	KW_FLAGS	274
-#define	KW_CATCHALL	275
-#define	KW_FALLBACK	276
-#define	KW_FINAL	277
-#define	KW_FSYNC	278
-#define	KW_MARK_FREQ	279
-#define	KW_SYNC_FREQ	280
-#define	KW_STATS_FREQ	281
-#define	KW_CHAIN_HOSTNAMES	282
-#define	KW_KEEP_HOSTNAME	283
-#define	KW_LOG_FIFO_SIZE	284
-#define	KW_TIME_REOPEN	285
-#define	KW_TIME_REAP	286
-#define	KW_USE_TIME_RECVD	287
-#define	KW_USE_DNS	288
-#define	KW_USE_FQDN	289
-#define	KW_GC_BUSY_THRESHOLD	290
-#define	KW_GC_IDLE_THRESHOLD	291
-#define	KW_CREATE_DIRS	292
-#define	KW_DIR_OWNER	293
-#define	KW_DIR_GROUP	294
-#define	KW_DIR_PERM	295
-#define	KW_FILE_TEMPLATE	296
-#define	KW_TEMPLATE_ESCAPE	297
-#define	KW_OWNER	298
-#define	KW_GROUP	299
-#define	KW_PERM	300
-#define	KW_KEEP_ALIVE	301
-#define	KW_MAX_CONNECTIONS	302
-#define	KW_LOCALIP	303
-#define	KW_IP	304
-#define	KW_LOCALPORT	305
-#define	KW_PORT	306
-#define	KW_DESTPORT	307
-#define	KW_COMPRESS	308
-#define	KW_MAC	309
-#define	KW_AUTH	310
-#define	KW_ENCRYPT	311
-#define	KW_DNS_CACHE	312
-#define	KW_DNS_CACHE_SIZE	313
-#define	KW_DNS_CACHE_EXPIRE	314
-#define	KW_DNS_CACHE_EXPIRE_FAILED	315
-#define	KW_FACILITY	316
-#define	KW_LEVEL	317
-#define	KW_HOST	318
-#define	KW_MATCH	319
-#define	KW_YES	320
-#define	KW_NO	321
-#define	KW_REQUIRED	322
-#define	KW_ALLOW	323
-#define	KW_DENY	324
-#define	DOTDOT	325
-#define	IDENTIFIER	326
-#define	NUMBER	327
-#define	STRING	328
-#define	KW_OR	329
-#define	KW_AND	330
-#define	KW_NOT	331
-
-#line 26 "cfg-grammar.y"
-
+#ifndef lint
+/*static char yysccsid[] = "from: @(#)yaccpar	1.9 (Berkeley) 02/21/93";*/
+static char yyrcsid[] = "$Id: skeleton.c,v 1.4 1993/12/21 18:45:32 jtc Exp $";
+#endif
+#define YYBYACC 1
+#define YYMAJOR 1
+#define YYMINOR 9
+#define yyclearin (yychar=(-1))
+#define yyerrok (yyerrflag=0)
+#define YYRECOVERING (yyerrflag!=0)
+#define YYPREFIX "yy"
+#line 27 "cfg-grammar.y"
 
 #include "cfgfile.h"
 #include "filters.h"
@@ -96,6 +24,7 @@
 #include "afremctrl.h"
 
 #include <netinet/in.h>
+#include <stdio.h>
 
 void yyerror(char *msg);
 int yylex();
diff -uNr syslog-ng-1.5.13.orig/src/cfg-grammar.c syslog-ng-1.5.13/src/cfg-grammar.c
--- syslog-ng-1.5.13.orig/src/cfg-grammar.c	Mon Sep  3 18:46:16 2001
+++ syslog-ng-1.5.13/src/cfg-grammar.c	Thu Apr 18 22:55:09 2002
@@ -1871,18 +1601,18 @@
 	    else
 	      yyval.num = (1 << n); 
 	    free(yyvsp[0].cptr); 
-	  ;
-    break;}
-case 191:
-#line 609 "cfg-grammar.y"
-{ yyval.num = yyvsp[-1].num + yyvsp[0].num; ;
-    break;}
-case 192:
-#line 610 "cfg-grammar.y"
-{ yyval.num = yyvsp[0].num; ;
-    break;}
-case 193:
-#line 615 "cfg-grammar.y"
+	  }
+break;
+case 197:
+#line 630 "cfg-grammar.y"
+{ yyval.num = yyvsp[-1].num + yyvsp[0].num; }
+break;
+case 198:
+#line 631 "cfg-grammar.y"
+{ yyval.num = yyvsp[0].num; }
+break;
+case 199:
+#line 636 "cfg-grammar.y"
 { 
 	    int r1, r2;
 	    r1 = syslog_lookup_level(yyvsp[-2].cptr);
@@ -1901,10 +1631,10 @@
 	      yyval.num = 0;
 	    free(yyvsp[-2].cptr); 
 	    free(yyvsp[0].cptr); 
-	  ;
-    break;}
-case 194:
-#line 635 "cfg-grammar.y"
+	  }
+break;
+case 200:
+#line 656 "cfg-grammar.y"
 { 
 	    int n = syslog_lookup_level(yyvsp[0].cptr); 
 	    if (n == -1)
@@ -1915,260 +1645,86 @@
 	    else
 	      yyval.num = 1 << sl_levels[n].value; 
 	    free(yyvsp[0].cptr); 
-	  ;
-    break;}
-case 195:
-#line 649 "cfg-grammar.y"
-{ yyval.num = 1; ;
-    break;}
-case 196:
-#line 650 "cfg-grammar.y"
-{ yyval.num = 0; ;
-    break;}
-case 197:
-#line 651 "cfg-grammar.y"
-{ yyval.num = yyvsp[0].num; ;
-    break;}
-case 198:
-#line 655 "cfg-grammar.y"
-{ yyval.num = 2; ;
-    break;}
-case 199:
-#line 656 "cfg-grammar.y"
-{ yyval.num = 1; ;
-    break;}
-case 200:
-#line 657 "cfg-grammar.y"
-{ yyval.num = 0; ;
-    break;}
-}
-   /* the action file gets copied in in place of this dollarsign */
-#line 543 "/usr/share/misc/bison.simple"
-
-  yyvsp -= yylen;
-  yyssp -= yylen;
-#ifdef YYLSP_NEEDED
-  yylsp -= yylen;
-#endif
-
-#if YYDEBUG != 0
-  if (yydebug)
-    {
-      short *ssp1 = yyss - 1;
-      fprintf (stderr, "state stack now");
-      while (ssp1 != yyssp)
-	fprintf (stderr, " %d", *++ssp1);
-      fprintf (stderr, "\n");
+	  }
+break;
+case 201:
+#line 670 "cfg-grammar.y"
+{ yyval.num = 1; }
+break;
+case 202:
+#line 671 "cfg-grammar.y"
+{ yyval.num = 0; }
+break;
+case 203:
+#line 672 "cfg-grammar.y"
+{ yyval.num = yyvsp[0].num; }
+break;
+case 204:
+#line 676 "cfg-grammar.y"
+{ yyval.num = 2; }
+break;
+case 205:
+#line 677 "cfg-grammar.y"
+{ yyval.num = 1; }
+break;
+case 206:
+#line 678 "cfg-grammar.y"
+{ yyval.num = 0; }
+break;
+#line 1675 "y.tab.c"
     }
-#endif
-
-  *++yyvsp = yyval;
-
-#ifdef YYLSP_NEEDED
-  yylsp++;
-  if (yylen == 0)
+    yyssp -= yym;
+    yystate = *yyssp;
+    yyvsp -= yym;
+    yym = yylhs[yyn];
+    if (yystate == 0 && yym == 0)
     {
-      yylsp->first_line = yylloc.first_line;
-      yylsp->first_column = yylloc.first_column;
-      yylsp->last_line = (yylsp-1)->last_line;
-      yylsp->last_column = (yylsp-1)->last_column;
-      yylsp->text = 0;
-    }
-  else
-    {
-      yylsp->last_line = (yylsp+yylen-1)->last_line;
-      yylsp->last_column = (yylsp+yylen-1)->last_column;
+#if YYDEBUG
+        if (yydebug)
+            printf("%sdebug: after reduction, shifting from state 0 to\
+ state %d\n", YYPREFIX, YYFINAL);
+#endif
+        yystate = YYFINAL;
+        *++yyssp = YYFINAL;
+        *++yyvsp = yyval;
+        if (yychar < 0)
+        {
+            if ((yychar = yylex()) < 0) yychar = 0;
+#if YYDEBUG
+            if (yydebug)
+            {
+                yys = 0;
+                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
+                if (!yys) yys = "illegal-symbol";
+                printf("%sdebug: state %d, reading %d (%s)\n",
+                        YYPREFIX, YYFINAL, yychar, yys);
+            }
+#endif
+        }
+        if (yychar == 0) goto yyaccept;
+        goto yyloop;
     }
+    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
+            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
+        yystate = yytable[yyn];
+    else
+        yystate = yydgoto[yym];
+#if YYDEBUG
+    if (yydebug)
+        printf("%sdebug: after reduction, shifting from state %d \
+to state %d\n", YYPREFIX, *yyssp, yystate);
 #endif
-
-  /* Now "shift" the result of the reduction.
-     Determine what state that goes to,
-     based on the state we popped back to
-     and the rule number reduced by.  */
-
-  yyn = yyr1[yyn];
-
-  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
-  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
-    yystate = yytable[yystate];
-  else
-    yystate = yydefgoto[yyn - YYNTBASE];
-
-  goto yynewstate;
-
-yyerrlab:   /* here on detecting error */
-
-  if (! yyerrstatus)
-    /* If not already recovering from an error, report this error.  */
+    if (yyssp >= yyss + yystacksize - 1)
     {
-      ++yynerrs;
-
-#ifdef YYERROR_VERBOSE
-      yyn = yypact[yystate];
-
-      if (yyn > YYFLAG && yyn < YYLAST)
-	{
-	  int size = 0;
-	  char *msg;
-	  int x, count;
-
-	  count = 0;
-	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
-	  for (x = (yyn < 0 ? -yyn : 0);
-	       x < (sizeof(yytname) / sizeof(char *)); x++)
-	    if (yycheck[x + yyn] == x)
-	      size += strlen(yytname[x]) + 15, count++;
-	  msg = (char *) malloc(size + 15);
-	  if (msg != 0)
-	    {
-	      strcpy(msg, "parse error");
-
-	      if (count < 5)
-		{
-		  count = 0;
-		  for (x = (yyn < 0 ? -yyn : 0);
-		       x < (sizeof(yytname) / sizeof(char *)); x++)
-		    if (yycheck[x + yyn] == x)
-		      {
-			strcat(msg, count == 0 ? ", expecting `" : " or `");
-			strcat(msg, yytname[x]);
-			strcat(msg, "'");
-			count++;
-		      }
-		}
-	      yyerror(msg);
-	      free(msg);
-	    }
-	  else
-	    yyerror ("parse error; also virtual memory exceeded");
-	}
-      else
-#endif /* YYERROR_VERBOSE */
-	yyerror("parse error");
+        goto yyoverflow;
     }
-
-  goto yyerrlab1;
-yyerrlab1:   /* here on error raised explicitly by an action */
-
-  if (yyerrstatus == 3)
-    {
-      /* if just tried and failed to reuse lookahead token after an error, discard it.  */
-
-      /* return failure if at end of input */
-      if (yychar == YYEOF)
-	YYABORT;
-
-#if YYDEBUG != 0
-      if (yydebug)
-	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
-#endif
-
-      yychar = YYEMPTY;
-    }
-
-  /* Else will try to reuse lookahead token
-     after shifting the error token.  */
-
-  yyerrstatus = 3;		/* Each real token shifted decrements this */
-
-  goto yyerrhandle;
-
-yyerrdefault:  /* current state does not do anything special for the error token. */
-
-#if 0
-  /* This is wrong; only states that explicitly want error tokens
-     should shift them.  */
-  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
-  if (yyn) goto yydefault;
-#endif
-
-yyerrpop:   /* pop the current state because it cannot handle the error token */
-
-  if (yyssp == yyss) YYABORT;
-  yyvsp--;
-  yystate = *--yyssp;
-#ifdef YYLSP_NEEDED
-  yylsp--;
-#endif
-
-#if YYDEBUG != 0
-  if (yydebug)
-    {
-      short *ssp1 = yyss - 1;
-      fprintf (stderr, "Error: state stack now");
-      while (ssp1 != yyssp)
-	fprintf (stderr, " %d", *++ssp1);
-      fprintf (stderr, "\n");
-    }
-#endif
-
-yyerrhandle:
-
-  yyn = yypact[yystate];
-  if (yyn == YYFLAG)
-    goto yyerrdefault;
-
-  yyn += YYTERROR;
-  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
-    goto yyerrdefault;
-
-  yyn = yytable[yyn];
-  if (yyn < 0)
-    {
-      if (yyn == YYFLAG)
-	goto yyerrpop;
-      yyn = -yyn;
-      goto yyreduce;
-    }
-  else if (yyn == 0)
-    goto yyerrpop;
-
-  if (yyn == YYFINAL)
-    YYACCEPT;
-
-#if YYDEBUG != 0
-  if (yydebug)
-    fprintf(stderr, "Shifting error token, ");
-#endif
-
-  *++yyvsp = yylval;
-#ifdef YYLSP_NEEDED
-  *++yylsp = yylloc;
-#endif
-
-  yystate = yyn;
-  goto yynewstate;
-
- yyacceptlab:
-  /* YYACCEPT comes here.  */
-  if (yyfree_stacks)
-    {
-      free (yyss);
-      free (yyvs);
-#ifdef YYLSP_NEEDED
-      free (yyls);
-#endif
-    }
-  return 0;
-
- yyabortlab:
-  /* YYABORT comes here.  */
-  if (yyfree_stacks)
-    {
-      free (yyss);
-      free (yyvs);
-#ifdef YYLSP_NEEDED
-      free (yyls);
-#endif
-    }
-  return 1;
-}
-#line 665 "cfg-grammar.y"
-
-
-extern int linenum;
-
-void yyerror(char *msg)
-{
-	fprintf(stderr, "%s at %d\n", msg, linenum);
+    *++yyssp = yystate;
+    *++yyvsp = yyval;
+    goto yyloop;
+yyoverflow:
+    yyerror("yacc stack overflow");
+yyabort:
+    return (1);
+yyaccept:
+    return (0);
 }
diff -uNr syslog-ng-1.5.13.orig/src/cfg-grammar.y syslog-ng-1.5.13/src/cfg-grammar.y
--- syslog-ng-1.5.13.orig/src/cfg-grammar.y	Mon Sep  3 18:46:01 2001
+++ syslog-ng-1.5.13/src/cfg-grammar.y	Thu Apr 18 22:55:03 2002
@@ -38,6 +38,7 @@
 #include "afremctrl.h"
 
 #include <netinet/in.h>
+#include <stdio.h>
 
 void yyerror(char *msg);
 int yylex();
@@ -125,6 +126,7 @@
 %type	<ptr> dest_afinet_tcp_params
 %type   <ptr> dest_afuser
 %type   <ptr> dest_afprogram
+%type   <ptr> dest_afprogram_params
 %type   <ptr> dest_afremctrl
 
 %type	<ptr> log_items
@@ -497,7 +499,26 @@
 	;
 
 dest_afprogram
-	: KW_PROGRAM '(' string ')' 		{ $$ = make_afprogram_dest($3); free($3); }
+	: KW_PROGRAM '(' dest_afprogram_params ')' 	{ $$ = $3; }
+
+dest_afprogram_params
+	: string 
+	  { 
+	    last_dest_driver = make_afprogram_dest($1);
+	    free($1); 
+	  } 
+	  dest_afprogram_options                   { $$ = last_dest_driver; }
+	;
+
+dest_afprogram_options
+	: dest_afprogram_option dest_afprogram_options
+	|
+	;
+
+dest_afprogram_option
+	: KW_FILE_TEMPLATE '(' string ')'       { afprogram_set_template(last_dest_driver, $3); free($3); }
+	| KW_TEMPLATE_ESCAPE '(' yesno ')'	{ afprogram_set_template_escape(last_dest_driver, $3); }
+	;
 
 dest_afremctrl
 	: KW_REMCTRL '(' ')'			{ $$ = make_afremctrl_dest(); }
